if(typeof(settings) != "undefined" && settings.platform() == "mac") {
  $("#windows-stylesheet").remove()
}

if (typeof(file) != "undefined") {
    $("body").attr("oncontextmenu", "return false");
}

App = Ember.Application.create({
    ready: function() {
        doResize();
        if(loginitem.launchedAtLogon()) {
          setTimeout(function () {
            App.StartAllForLogon();
          }, 1000);
        }
        setTimeout((function() {
          App.license.validate();
        }), 200);


    }
});

App.connectionDB = null;

App.StartAllForLogon = function() {
  ic = window.App.__container__.lookup('controller:index')
  ac = ic.get("arrangedContent")
  for(var i = 0; i < ac.get("length"); i++) {
    if(ac[i].get("reconnectAtLogon") == true) {
      ac[i].connect();
    }
  }
};


App.AllDrives = function() {
  ic = window.App.__container__.lookup('controller:index')
  ac = ic.get("arrangedContent")
  drives = [];

  for(var i = 0; i < ac.get("length"); i++) {
    cj = ac[i].cleanJSON();
    cj["status"] = ac[i].get("status");
    drives.push(cj);
  }
  return JSON.stringify(drives);
};

App.ListDrives = function() {
  ret =  "=== Available drives\n"
  db = window.App.__container__.lookup('controller:application').get("connectionDB");
  for(var i = 0; i < db.length; i++) {
    ret += db[i]["name"] + " (" + db[i]["id"] + ")\n"
  }

  return ret;
}

App.ConnectDrive = function(name) {
  db = window.App.__container__.lookup('controller:index').get("content");
  ret = "Could not find a drive named: " + name + "\n";
  for(var i = 0; i < db.get("length"); i++) {
    if(name == db.objectAt(i).get("id") || name == db.objectAt(i).get("name")) {
      db.objectAt(i).connect();
      ret = "";
    }
  }
  return ret;
}

App.EjectDrive = function(name) {
  db = window.App.__container__.lookup('controller:index').get("content");
  ret = "Could not find a drive named: " + name + "\n";
  for(var i = 0; i < db.get("length"); i++) {
    if(name == db.objectAt(i).get("name")) {
      db.objectAt(i).eject();
      ret = "";
    }
  }
  return ret;
}

App.sendMessage = function(id, message) {

    indexController = window.App.__container__.lookup('controller:index');
    for(var i = 0; 1; i++)
    {
        model = indexController.objectAt(i);
        if(model == undefined)
            break;
        if(model.id == id) {
            model.activity(message);
        }
    }
};

App.applicationShouldTerminate = function() {
  return true;
}

var attr = Ember.attr;





App.Router.map(function() {
    this.route("new");
    this.route("settings");
    this.route("license");
    this.route("welcome");
});



$(document).keydown(function(e) {

    if(e.keyCode == 38) {
      e.preventDefault();
      indexController = window.App.__container__.lookup('controller:index');
      indexController.selectPreviousObject();
    }

    if(e.keyCode == 40) {
      e.preventDefault();
      indexController = window.App.__container__.lookup('controller:index');
      indexController.selectNextObject();
    }

    if(e.keyCode == 13) {
      e.preventDefault();
      indexController = window.App.__container__.lookup('controller:index');
      indexController.connectSelectedConnection();
    }



});

App.ApplicationView = Em.View.extend({
    classNames: ['full-height']
});


Ember.TextField.reopen({
  attributeBindings: ['autofocus']
}); 

window.oauthemail = null;
window.oauthrefresh = null;

window.setOauthCredentials = function(email, refresh){
    window.oauthemail = email;
    window.oauthrefresh = refresh;
}


$(window).on('resize orientationChanged', function() {
    doResize();
});

App.ApplicationController = Ember.Controller.extend({
  platform: function() {
      return "platform_mac";
  }.property(),

  isPlatformMac: function() {
      return settings.platform() == "mac";
  }.property(),

  isPlatformWindows: function() {
      return !this.get("isPlatformMac");
  }.property(),
  
  hasDrives: function() {
      return this.get("connectionDBlength") > 0;
  }.property("connectionDBlength"),

  connectionDB: [],

  connectionDBlength: 0,
});

doResize = function() {
  // viewportWidth = $(window).width();
  
  // if(viewportWidth < 850) {
  //   $("#details").addClass("hide");
  //   $("#connections").width(viewportWidth - 76);
  // } else {
  //   $("#details").removeClass("hide");
  //   $("#connections").width(300);
  // }
};


function parseURL(url) {
    var a =  document.createElement('a');
    a.href = url;
    return {
        source: url,
        protocol: a.protocol.replace(':',''),
        host: a.hostname,
        port: a.port,
        query: a.search,
        params: (function(){
            var ret = {},
                seg = a.search.replace(/^\?/,'').split('&'),
                len = seg.length, i = 0, s;
            for (;i<len;i++) {
                if (!seg[i]) { continue; }
                s = seg[i].split('=');
                ret[s[0]] = s[1];
            }
            return ret;
        })(),
        file: (a.pathname.match(/\/([^\/?#]+)$/i) || [,''])[1],
        hash: a.hash.replace('#',''),
        path: a.pathname.replace(/^([^\/])/,'/$1'),
        relative: (a.href.match(/tps?:\/\/[^\/]+(.+)/) || [,''])[1],
        segments: a.pathname.replace(/^\//,'').split('/')
    };
}